unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    N1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;



var
  Form1: TForm1;

implementation

uses
 EffectBass;

{$R *.DFM}

//-----------------------------------------------------------------------------
//֐@   EffectUnSharpMask
//pr     AVF[v}XN
//     hBMP             ...]̃rbg}bṽnh
//߂l
//            Vrbg}bṽnh
//-----------------------------------------------------------------------------
function EffectUnSharpMask(hBMP: HBitmap):HBitmap;
var
  Row,Col,yRow,xCol,r,g,b,X,y: Integer;
  SrcRow,DestRow  : pRGBArray;
  _Height,_Width  : integer;
  SrcBitmap,DestBitmap     : TBitmap;
  SourceBits      :PPBits;
begin
 SrcBitmap   :=TBitmap.Create;
 DestBitmap  :=TBitmap.Create;
 SrcBitmap.Handle  :=hBMP;
 Set24bit(SrcBitmap,DestBitmap);
 _Height := SrcBitmap.height-1;
 _Width  := SrcBitmap.width-1;

   GetMem(SourceBits, SrcBitmap.Height * SizeOf(pRGBArray));
try
   //|C^Ƀ|C^n
   for Row:= 0 to SrcBitmap.Height - 1 do  SourceBits[Row]:=SrcBitmap.Scanline[Row];

   For Row := 0 To _Height   do
   begin
        DestRow:=DestBitmap.ScanLine[Row];

        For Col := 0 To _Width do
        begin
            //-------------
            // 0 - 1 - 2
            //-------------
            // 3 - 4 - 5
            //-------------
            // 6 - 7 - 8
            //-------------
            R:=0;G:=0;B:=0;
            for y:= -1 to 1 do
            begin
              for x:= -1 to 1 do
              begin
                 //Y
                 if      Row+(y)> _Height then
                  yRow:=_Height
                 else if Row+(y)< 0       then
                  yRow:=0
                 else
                   yRow:=Row+(y);
                 //X
                 if      Col+(x)> _Width  then  xCol:=_Width
                 else if Col+(x)< 0       then  xCol:=0
                 else
                   xCol:=Col+(x);

                 B:=B+(SourceBits[yRow][xCol].rgbtBlue);
                 G:=G+(SourceBits[yRow][xCol].rgbtGreen);
                 R:=R+(SourceBits[yRow][xCol].rgbtRed);
              end;
            end;

           DestRow[Col].rgbtRed   :=Set255(R div 9);
           DestRow[Col].rgbtGreen :=Set255(G div 9);
           DestRow[Col].rgbtBlue  :=Set255(B div 9);
       end;
    end;

  For Row := 0 To _Height   do
  begin
     SrcRow:= SrcBitmap.ScanLine[Row];
     DestRow:=DestBitmap.ScanLine[Row];
     For Col := 0 To _Width do
     begin
         DestRow[Col].rgbtRed   :=Set255(128+(SrcRow[Col].rgbtRed-DestRow[Col].rgbtRed)*2);
         DestRow[Col].rgbtGreen :=Set255(128+(SrcRow[Col].rgbtGreen-DestRow[Col].rgbtGreen)*2);
         DestRow[Col].rgbtBlue  :=Set255(128+(SrcRow[Col].rgbtBlue-DestRow[Col].rgbtBlue)*2);
     end;
  end;

  FreeMem(SourceBits); SourceBits:=nil;
  Result :=DestBitmap.ReleaseHandle;

  except
     if Assigned(SourceBits) then FreeMem(SourceBits);
     Result :=SrcBitmap.ReleaseHandle;
  end;
  SrcBitmap.Free ;
  DestBitmap.Free;
end;




/////////
procedure TForm1.Open1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
 begin
   Image1.Picture.bitmap.LoadFromFIle(OpenDialog1.FIlename);
   N1.Enabled :=true;
 end;
end;

/////////
procedure TForm1.N1Click(Sender: TObject);
begin
 //Run
 Image1.Picture.bitmap.Handle:= EffectUnSharpMask(Image1.Picture.Bitmap.ReleaseHandle);
end;

end.
